import java.util.HashMap;

// we use this on both the sender and the receiver side to dispatch
// TCP packets to the appropriate TCP end-point, which might be a
// receiver or a sender.
//
public class TCPMultiplexer implements TransportReceiver {
    Link link;
    HashMap<Integer, TransportReceiver> receivers = new HashMap<Integer, TransportReceiver>();

    public void add(TCPSender s) {
	receivers.put(s.src_port, s);
    }

    public void add(TCPReceiver r) {
	receivers.put(r.src_port, r);
    }

    public void connect(Link l) {
	link = l;
    }

    public void deliver(Packet packet) {
	if (packet instanceof TCPPacket) {
	    TCPPacket p = (TCPPacket)packet;
	    TransportReceiver r = receivers.get(p.dst_port);
	    if (r == null) {
		System.out.printf("%f ", Simulation.time());
		System.out.println("TCPMultiplexer: no TCP endpoint on port " + p.dst_port); 
	    } else {
		r.deliver(p);
	    }
	}
    }
}
